#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__="Speirs"

import sys, re, subprocess

#nodes = subprocess.Popen(["./osmconvert", "--drop-relations", "--drop-ways", sys.argv[1]], stdout=subprocess.PIPE)
#ways = subprocess.Popen(["./osmconvert", "--drop-relations", "--drop-nodes", sys.argv[1]], stdout=subprocess.PIPE)
mapFile = subprocess.Popen(["./osmconvert", sys.argv[1]], stdout=subprocess.PIPE)
relations = subprocess.Popen(["./osmconvert", "--drop-nodes", "--drop-ways", sys.argv[1]], stdout=subprocess.PIPE)

nodeStart = re.compile('\s*<node id="(\d+)" lat="([0-9.]*)" lon="([0-9.]*)"')
nodeEnd = re.compile('\s*</node>')
wayStart = re.compile('\s*<way id="(\d+)"\s')
wayEnd = re.compile('\s*</way>')
relationStart = re.compile('\s*<relation id="(\d+)"')
relationEnd = re.compile('\s*</relation>')

nodeID = re.compile( '\s*<nd ref="(\d+)"')
hikeRoute = re.compile('\s*<tag k=\"route\" v=\"(hiking|foot)\"')
kctRoute = re.compile('\s*<tag k=\"kct_.+\" v=\"')
bikeRoute = re.compile('\s*<tag k=\"route\" v=\"(bicycle|mtb)\"')
tag = re.compile('\s*<tag k=\"(.+)\" v=\"(.+)\"')
member = re.compile('\s*<member type="(.+)" ref="(.+)"\s')

stack = []
wayTags = {}

def compare(a, b):
        return cmp(int(a), int(b))

def combine(i, l):
    for key, value in l.items():
        if (key in ('name', 'ref')) and (key in wayTags[i]):
            if value not in wayTags[i][key].split(','):
                wayTags[i][key] = wayTags[i][key] + ',' + value
        else:
            wayTags[i][key] = value

def printTag(key, value):
        print '\t\t<tag k="{}" v="{}"/>'.format(key, value)

def hikingRoute(l):
    wayIds = []
    tags = {}
    kctKeys = ('kct_red', 'kct_blue', 'kct_green', 'kct_yellow')
    kctValues = ('major', 'local', 'peak', 'learning', 'ruin', 'spring', 'horse', 'bicycle', 'ski', 'wheelchair', 'interesting_object')

    for line in l:
        t = tag.match(line)
        m = member.match(line)
        if m:
            if m.group(1) == 'way':
                wayIds.append(m.group(2))
            elif t:
                if t.group(1) in kctKeys:
                    kct = t.group(1).split('_')
                    typ = t.group(2).split(';')
                    tags[t.group(1)] = typ[0]
                    tags['osmc'] = 'yes'
                    tags['osmc_color'] = kct[1]
                    if typ[0] in ('major', 'local', 'peak', 'learning', 'ruin', 'spring', 'horse', 'wheelchair', 'interesting_object'):
                        tags['osmc_background'] = 'white'
                    elif typ[0] == 'bicycle':
                        tags['osmc_background'] = 'yellow'
                    elif typ[0] == 'ski':
                        tags['osmc_background'] = 'orange'

                    if typ[0] in ('major', 'bicycle', 'ski'):
                        tags['osmc_foreground'] = kct[1] + '_bar'
                    elif typ[0]== 'peak':
                        tags['osmc_foreground'] = kct[1] + '_triangle'
                    elif typ[0] == 'local':
                        tags['osmc_foreground'] = kct[1] + '_corner'
                    elif typ[0] == 'interesting_object':
                        tags['osmc_foreground'] = kct[1] + '_turned_T'
                    elif typ[0] == 'ruin':
                        tags['osmc_foreground'] = kct[1] + '_L'
                    elif typ[0] == 'spring':
                        tags['osmc_foreground'] = kct[1] + '_bowl'
                    elif typ[0] == 'horse':
                        tags['osmc_foreground'] = kct[1] + '_dot'
                    elif typ[0] == 'wheelchair':
                        tags['osmc_foreground'] = kct[1] + '_wheelchair'
                    elif typ[0] == 'learning':
                        tags['osmc_foreground'] = kct[1] + '_backslash'

        for i in wayIds:
            if i in wayTags:
                combine(i, tags)
                #wayTags[i].update(tags)
            else:
                wayTags[i] = {}
                for key, value in tags.items():
                    wayTags[i][key] = value

        tags.clear()
        del wayIds[:]

def bikingRoute(l):
    wayIds = []
    tags = {}
    for line in l:
        t = tag.match(line)
        m = member.match(line)
        if m:
            if m.group(1) == 'way':
                wayIds.append(m.group(2))
            elif t:
                if t.group(1) in ('network', 'ref', 'route'):
                    tags[t.group(1)] = t.group(2)

        for i in wayIds:
            if i in wayTags:
                combine(i, tags)
                #wayTags[i].update(tags)
            else:
                wayTags[i] = {}
                for key, value in tags.items():
                    wayTags[i][key] = value
        tags.clear()
        del wayIds[:]

flag = 0
for line in relations.stdout:
    relS = relationStart.match(line)
    relE = relationEnd.match(line)
    hikeR = kctRoute.match(line)
    bikeR = bikeRoute.match(line)
    if relS:
        flag = -1
    elif relE:
        if flag == 1:
            hikingRoute(stack)
        elif flag == 2:
            bikingRoute(stack)
        del stack[:]
        flag = 0
    elif hikeR:
        flag = 1
        stack.append(line)
    elif bikeR:
        flag = 2
        stack.append(line)
    elif flag != 0:
        stack.append(line)

id = -1
h = 0
b = 0
for line in mapFile.stdout:
    s = wayStart.match(line)
    e = wayEnd.match(line)
    hi = kctRoute.match(line)
    bi = bikeRoute.match(line)
    if s:
        id = s.group(1)
    elif hi:
        h = 1
    elif bi:
        b = 1
    elif e:
        if id != -1:
            if id in wayTags:
                for key, value in wayTags[id].items():
                    if h == 0 and (value in ('major', 'local', 'peak', 'learning', 'ruin', 'spring', 'horse', 'wheelchair', 'interesting_object')):
                        printTag('route', 'hiking')
                        h = 1
                    elif key == 'route' and value == 'bicycle':
                        b = 1
                    elif b == 0 and value == 'bicycle':
                        printTag('route', 'bicycle')
                        b = 1
                    printTag(key, value)
                del wayTags[id]
                h = 0
                b = 0
        id = -1
    print line.rstrip()

exit(0)
